// Word Cloud Example
// Step 1: Acquire, Parse, and Display
import java.util.Map.Entry;
import java.util.Map;
String inputTextFile = "waronchristmas.txt";
String [] fileContents;
String rawText;
String [] tokens;
String delimiters = " ,./?<>;:'\"[{]}\\|=+-_()*&^%$#@!~";
int NUM_WORDS = 50;

HashMap<String, Integer> wordCountSet = 
new HashMap<String, Integer>();

void setup() {
  size(1000, 800);
  background(0);
  // Input and parse text file
  fileContents = loadStrings(inputTextFile);
  rawText = join(fileContents, " ");
  rawText = rawText.toLowerCase();
  tokens = splitTokens(rawText, delimiters);
  // print out the number of tokens found
  println(tokens.length+" tokens found in file: "+inputTextFile);

  wordCountSet = makeWordPairs(tokens);

  //print(wordCountSet);

  int max = getMaxWordCount();
  ArrayList<WordFreqTile> sortedWordFreqTiles = getTopWords(NUM_WORDS);
  
  // display words
  for(WordFreqTile t : sortedWordFreqTiles) {
    t.setXY(random(0, width-50), random(20, height));
    t.setFontSize(max);
    t.display();
  }
} // setup()

// display at most num words
ArrayList<WordFreqTile> getTopWords(int num) {
  ArrayList<WordFreqTile> retList = new ArrayList<WordFreqTile>();
  while (retList.size () < num) {
    int frequency = 0;
    String word = "";
    for (Map.Entry e : wordCountSet.entrySet ()) { 
      if (frequency < (Integer)e.getValue()) {
        word = (String)e.getKey();
        frequency = (Integer)e.getValue();
      }
    }
    wordCountSet.remove(word);
    WordFreqTile tile = new WordFreqTile(word, frequency);
    if (random(100) > 40) {
      tile.tileColor = color(random(150, 250), 0, 0, 190);
    } else {
      tile.tileColor = color(0, random(150, 250), 0, 190);
    }
    retList.add(tile);
  } // while
  return retList;
}

HashMap<String, Integer> makeWordPairs(String[] words) {
  HashMap<String, Integer> wordPairs = 
    new HashMap<String, Integer>();
  for (String w : words) {
    Integer wordFrequency = wordPairs.get(w);
    if (wordFrequency != null) {
      wordPairs.put(w, wordFrequency+1);
    } else {
      wordPairs.put(w, 1);
    }
  }

  return wordPairs;
}

int getMaxWordCount() {
  int max = 0;
  for (Integer val : wordCountSet.values ()) {
    if (max < val) {
      max = val;
    }
  } 
  return max;
}

